/**
 * Utilities for using Promises. Should be stateless.
 *
 * @CLIENT_SERVER
 */"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports["default"] = 
{ 
  /**
   * Runs all promises inside the array in parallel. Will reject if any of
   * the given promises rejects.
   *
   * NOTE: I know I can use Promise.all() - but preliminary investigation
   * seems to conclude that it runs promises serially? Correct me if I'm wrong.
   *
   * @param {Promise} Promise
   * @param {Array<Promise>} promises
   * @returns {Promise}
   */
  allParallel: function allParallel(Promise, promises) {var _this = this;
    return new Promise(function (resolve, reject) {
      var i, result = [];
      var registerResult = function registerResult(index, value) {
        result[index] = value;
        if (result.length == promises.length) {
          resolve(result);}};


      for (i = 0; i < promises.length; i++) {
        promises[i].then(_this.createResolveFunc(i, registerResult), function (error) {
          reject(error);});}});}, 





  /**
   * @param {number} index
   * @param {Function} resolver
   * @returns {Function}
   */
  createResolveFunc: function createResolveFunc(index, resolver) {
    return function (value) {
      resolver(index, value);};} };module.exports = exports["default"];
//# sourceMappingURL=PromiseUtil.js.map