'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _ActionCreatorJs = require('../../ActionCreator.js');var _ActionCreatorJs2 = _interopRequireDefault(_ActionCreatorJs);var _ActionNameUtilJs = require(
'../ActionNameUtil.js');var _ActionNameUtilJs2 = _interopRequireDefault(_ActionNameUtilJs);

var Promise;

/**
 * Abstract implementation, to be used in tandem with MapSegment. Handles
 * caching so that user only need to define the action creator.
 *
 * @CLIENT_SERVER
 */var 
MapActionCreator = (function (_ActionCreator) {_inherits(MapActionCreator, _ActionCreator);










  /**
   * @param {string} segmentName
   */
  function MapActionCreator(segmentName) {_classCallCheck(this, MapActionCreator);
    _get(Object.getPrototypeOf(MapActionCreator.prototype), 'constructor', this).call(this);
    // Since segment name is guaranteed never to clash by ReduxStore, we can
    // safely use segment name as action type.
    this._actionType = _ActionNameUtilJs2['default'].generate(segmentName, 'LOAD');
    this._cache = {};}


  /**
   * @param {any} query
   * @param {Object} options
   * @param {?boolean} forceLoad
   * @return {Object | Function}
   */_createClass(MapActionCreator, [{ key: 'createLoadAction', value: 
    function createLoadAction(query, options, forceLoad) {
      forceLoad = forceLoad == null ? false : forceLoad;
      var queryId = this._generateQueryId(query);
      return this._createLoadActionWithQueryId(query, options, forceLoad, queryId);}


    /**
     * TODO: Implement caching.
     * TODO: Implement polling.
     *
     * @param {any} query
     * @param {options} options
     * @param {boolean} forceLoad
     * @param {string} queryId
     * @return {Object | Function}
     */ }, { key: '_createLoadActionWithQueryId', value: 
    function _createLoadActionWithQueryId(query, options, forceLoad, queryId) {
      return this._createThunkAction(query, queryId);}


    /**
     * Returns a thunk function that returns a Promise. Returned function accepts
     * dispatch.
     *
     * ABSTRACT: To be overridden by child classes.
     *
     * @param {any} query
     * @param {string} queryId
     * @return {Function}
     */ }, { key: '_createThunkAction', value: 
    function _createThunkAction(query, queryId) {}



    /**
     * Generates a unique string representing the given query. Same query must
     * generate identical strings. Query ID is used by ReduxStore and Segment
     * to recognize identical queries.
     *
     * ABSTRACT: To be overridden by child implementations.
     *
     * @param {any} query
     * @return {string}
     */ }, { key: '_generateQueryId', value: 
    function _generateQueryId(query) {}



    /**
     * @param {Promise} PromiseImpl
     */ }, { key: '_setPromise', value: 
    function _setPromise(PromiseImpl) {
      Promise = PromiseImpl;}


    /**
     * Called by MapSegment when creating its reducer.
     *
     * @return {string}
     */ }, { key: '_getActionType', value: 
    function _getActionType() {
      return this._actionType;} }]);return MapActionCreator;})(_ActionCreatorJs2['default']);exports['default'] = MapActionCreator;module.exports = exports['default']; /**
                                                                                                                                                                         * @type {string}
                                                                                                                                                                         */ /**
                                                                                                                                                                             * @type {{[key: string]: {action: Object; expiry: number;}}}
                                                                                                                                                                             */
//# sourceMappingURL=MapActionCreator.js.map