'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _SegmentJs = require('../../Segment.js');var _SegmentJs2 = _interopRequireDefault(_SegmentJs);var _QueryOptionUtilJs = require(
'../QueryOptionUtil.js');var _QueryOptionUtilJs2 = _interopRequireDefault(_QueryOptionUtilJs);

/**
 * Promise implementation, in local variable so that our code can be natural.
 *
 * @type {Function}
 */
var Promise;

/**
 * Organizes pieces inside its segment as simple key-value map. This means
 * segment piece granularity is limited to top-level values (you cannot
 * query a particular field, for instance).
 *
 * @CLIENT_SERVER
 */var 
MapSegment = (function (_Segment) {_inherits(MapSegment, _Segment);










  /**
   *
   */
  function MapSegment() {_classCallCheck(this, MapSegment);
    _get(Object.getPrototypeOf(MapSegment.prototype), 'constructor', this).call(this);
    this._queries = {};}


  /**
   * Creates MapActionCreator implementation. Will only be called once.
   *
   * ABSTRACT: To be overridden by child implementation.
   *
   * @return {MapActionCreator}
   */_createClass(MapSegment, [{ key: '_createActionCreator', value: 
    function _createActionCreator() {}



    /**
     * Child classes may want override merging behavior.
     *
     * @param {Object} optionA
     * @param {Object} optionB
     */ }, { key: '_mergeOptions', value: 
    function _mergeOptions(optionA, optionB) {
      return _QueryOptionUtilJs2['default'].mergeOptions(optionA, optionB);}


    /**
     * @param {Function} PromiseImpl
     */ }, { key: '_activate', value: 
    function _activate(PromiseImpl) {
      Promise = PromiseImpl;
      if (!this._actionCreator) {
        this._actionCreator = this._createActionCreator();}

      if (!(this._actionCreator instanceof MapActionCreator)) {
        throw new Error('MapSegment must be used in tandem with MapActionCreator.');}

      this._actionCreator._setPromise(PromiseImpl);}


    /**
     * We need to store both queries and options for later use. If the query is
     * already registered, we merge its options.
     *
     * @param {any} query
     * @param {Object} options
     */ }, { key: '_registerQuery', value: 
    function _registerQuery(query, options) {
      options = _QueryOptionUtilJs2['default'].initOptions(options);
      var queryId = this._actionCreator._generateQueryId(query);
      if (this._queries.hasOwnProperty(queryId)) {
        this._queries[queryId].options = this._mergeOptions(
        options, this._queries[queryId].options);} else 
      {
        this._queries[queryId] = { 
          query: query, 
          options: options };}}




    /**
     * @param {string} queryId
     * @return {Object | Function}
     */ }, { key: '_createHydrateAction', value: 
    function _createHydrateAction(queryId) {
      return this._actionCreator.createLoadAction(
      this._queries[queryId].query, 
      this._queries[queryId].options, 
      true);}



    /**
     * @return {MapActionCreator}
     */ }, { key: '_getActionCreator', value: 
    function _getActionCreator() {
      return this._actionCreator;}


    /**
     * @param {Object} state
     * @param {string} queryId
     */ }, { key: '_getPieceObject', value: 
    function _getPieceObject(state, queryId) {
      return state[queryId];}


    /**
     * @param {any} segmentStateA
     * @param {any} segmentStateB
     * @return {boolean}
     */ }, { key: '_isStateEqual', value: 
    function _isStateEqual(segmentStateA, segmentStateB) {
      // We're not using immutable because we store simple maps.
      return segmentStateA === segmentStateB;}


    /**
     * @param prevSegmentState
     * @param segmentState
     * @param queryId
     * @return {?{data: ?any; errors: ?any}}
     */ }, { key: '_comparePiece', value: 
    function _comparePiece(prevSegmentState, segmentState, queryId) {
      if (this._isStateEqual(prevSegmentState, segmentState)) {
        return null;}

      return this._getPieceObject(segmentState, queryId);}


    /**
     * @return {Function}
     */ }, { key: '_getReducer', value: 
    function _getReducer() {
      var loadActionType = this._actionCreator._getActionType();
      return function (state, action) {
        var queryId, newState = {};
        if (!state) return newState;
        switch (action.type) {
          case loadActionType:
            for (queryId in state) {
              if (!state.hasOwnProperty(queryId)) continue;
              newState[queryId] = state[queryId];}

            newState[action.queryId] = action.payload;
            return newState;
            break;
          default:
            return state;}};} }]);return MapSegment;})(_SegmentJs2['default']);exports['default'] = MapSegment;module.exports = exports['default']; /**
                                                                                                                                                     * @type {{[key: string]: {query: any; options: Object}}}
                                                                                                                                                     */ /**
                                                                                                                                                         * @type {MapActionCreator}
                                                                                                                                                         */
//# sourceMappingURL=MapSegment.js.map