/**
 * Represents a cookie.
 *
 * @CLIENT-SERVER
 */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var 
Cookie = (function () {_createClass(Cookie, null, [{ key: 'createExpireInDays', 






























    /**
     * Create a cookie which expires after N more days from now.
     *
     * @param {string} name
     * @param {string} value
     * @param {number} expireInDays
     * @param {string} domain
     * @param {?boolean} secure
     * @param {?string} path
     */value: 
    function createExpireInDays(name, value, domain, expireInDays, secure, path) {
      var msecToAdd = expireInDays * 24 * 60 * 60 * 1000;
      return Cookie.createExpireInMsec(name, value, domain, msecToAdd, secure, path);}


    /**
     * Create session cookie that should expire after browser is closed.
     *
     * IMPORTANT NOTE: The days have long passed when web developers can rely
     * on this technique. The thing is some browsers do not clear session cookies
     * if options like 'Remember previously opened tabs' are enabled - leaving
     * your 'session' cookie to exist effectively forever. Only use this if you
     * have control over your user's browser settings.
     *
     * @param {string} name
     * @param {string} value
     * @param {string} domain
     * @param {?boolean} secure
     * @param {?string} path
     */ }, { key: 'createSession', value: 
    function createSession(name, value, domain, secure, path) {
      return new Cookie(name, value, domain, null, secure, path);}


    /**
     * Create a cookie that expires after N milliseconds from now.
     *
     * @param {string} name
     * @param {string} value
     * @param {number} expireInMsec
     * @param {string} domain
     * @param {?boolean} secure
     * @param {?string} path
     */ }, { key: 'createExpireInMsec', value: 
    function createExpireInMsec(name, value, domain, expireInMsec, secure, path) {
      var expire = Date.now() + expireInMsec;
      return new Cookie(name, value, domain, expire, secure, path);}


    /**
     * @param {string} cookieName
     * @param {string} domain
     * @param {?string} path
     * @returns {Cookie}
     */ }, { key: 'createRemoval', value: 
    function createRemoval(cookieName, domain, path) {
      if (!path) path = '/';
      return new Cookie(cookieName, '', domain, -1, path);}


    /**
     * @param {string} name
     * @param {string} value
     * @param {string} domain
     * @param {?number} expire
     * @param {?boolean} secure
     * @param {?string} path
     */ }]);
  function Cookie(name, value, domain, expire, secure, path) {_classCallCheck(this, Cookie);
    this.name = name;
    this.value = value;
    this.expire = expire;
    this.domain = domain;
    this.secure = !!secure;
    this.path = path ? path : '/';}


  /**
   * @return {string}
   */_createClass(Cookie, [{ key: 'toHeaderString', value: 
    function toHeaderString() {
      var expireString = '', secureString = '', domainString = '', cookie;
      if (this.expire) {
        expireString = ';Expires=' + new Date(this.expire).toGMTString();}

      if (this.secure) {
        secureString = ';Secure';}

      if (this.domain) {
        domainString = ';Domain=' + this.domain;}


      // TODO: We should escape some characters when printing these.
      cookie = this.name + '=' + this.value + ';Path=' + this.path + domainString + expireString + secureString;
      return cookie;} }]);return Cookie;})();exports['default'] = Cookie;module.exports = exports['default']; /**
                                                                                                               * @type {string}
                                                                                                               */ /**
                                                                                                                   * @type {string}
                                                                                                                   */ /**
                                                                                                                       * @type {?number}
                                                                                                                       */ /**
                                                                                                                           * @type {string}
                                                                                                                           */ /**
                                                                                                                               * @type {?string}
                                                                                                                               */ /**
                                                                                                                                   * @type {boolean}
                                                                                                                                   */
//# sourceMappingURL=Cookie.js.map