'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _RenderResultJs = require('./RenderResult.js');var _RenderResultJs2 = _interopRequireDefault(_RenderResultJs);var _httpServerHttpRequestJs = require(
'../http/ServerHttpRequest.js');var _httpServerHttpRequestJs2 = _interopRequireDefault(_httpServerHttpRequestJs);var _httpClientHttpRequestJs = require(
'../http/ClientHttpRequest.js');var _httpClientHttpRequestJs2 = _interopRequireDefault(_httpClientHttpRequestJs);

/**
 * Represents a web page with URL link. There are three different situations
 * where this class is used:
 *
 * 1. At server side, to generate HTML string.
 * 2. At client side after HTML is loaded, to create the main react element
 *    with the appropriate props so that it can start attaching event handlers.
 * 3. At client side at dynamic page change, to modify <head>, add JS and CSS
 *    dependencies, and render the main react component.
 *
 * NOTE: This class is supposed to be stateless. Only one instance is created
 * at server side and init() is only called once.
 *
 * @CLIENT-SERVER
 */var 
Page = (function () {
  /**
   * This method is run in both server and client side. This method should
   * instantiate all dependencies using the given config object and static
   * factories. The logic that it does should be the same since dependency
   * creation is offload to static factories, which are replaced by their
   * client side version at code compilation process.
   *
   * NOTE: Since Page is supposed to be stateless, init method is not given any
   * request context. You are supposed to only instantiate dependencies that
   * are reusable in all requests.
   *
   * @param {Object} config
   * @param {PageRouter} router
   */
  function Page(config, router) {_classCallCheck(this, Page);
    this.config = config;
    this.router = router;}


  /**
   * Returns an array of string IDs. This method specifies IDs of routes that
   * this page wanted to use for reverse-routing (URL generation).
   *
   * @returns {Array<string>}
   */_createClass(Page, [{ key: 'getRouteRequirements', value: 
    function getRouteRequirements() {
      return [];}


    /**
     * This method is also run in both server and client side. On server side,
     * framework code will generate a complete HTML document from RenderResult.
     * On client side, framework will just run the instantiated ReactComponent.
     *
     * NOTE: We need to use callback because we don't want the framework code
     * to depend on third party promise library.
     *
     * @param {ServerHttpRequest | ClientHttpRequest} httpRequest
     * @param {Object} routeArgs
     * @param {Function} complete
     */ }, { key: 'render', value: 
    function render(httpRequest, routeArgs, complete) {
      complete(new _RenderResultJs2['default']());} }]);return Page;})();exports['default'] = Page;module.exports = exports['default'];
//# sourceMappingURL=Page.js.map