'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _RoutingData = require('./RoutingData');var _RoutingData2 = _interopRequireDefault(_RoutingData);

/**
 * Extend this class or create a custom class that owns the same methods as
 * this one to modify routing behavior.
 *
 * IMPORTANT NOTE: Node classes will be executed in both server and client side.
 * Please ensure that your implementation does not load and use node specific
 * APIs.
 *
 * @CLIENT-SERVER
 */var 
Node = (function () {





  function Node() {_classCallCheck(this, Node);
    this._children = [];}


  /**
   * @returns {boolean}
   */_createClass(Node, [{ key: 'isLeaf', value: 
    function isLeaf() {
      return this._children.length <= 0;}


    /**
     * @param {Node} node
     */ }, { key: 'addChild', value: 
    function addChild(node) {
      this._children.push(node);}


    /**
     * @returns {Array<Node>}
     */ }, { key: 'getChildren', value: 
    function getChildren() {
      return this._children;}


    /**
     * @return {string}
     */ }, { key: 'getType', value: 
    function getType() {
      throw new Error('Node implementation does not implement this required method.');}


    /**
     * Returns true if the current active path segment (or other request specific
     * metadata) matches. If something other than true is returned, the routing
     * will stop and not found route result will be returned.
     *
     * @param {RoutingData} routingData
     * @return {boolean}
     */ }, { key: 'evaluate', value: 
    function evaluate(routingData) {
      throw new Error('Node implementation does not implement this required method.');}


    /**
     * @param {ReverseRoutingData} reverseRoutingData
     */ }, { key: 'reverseEvaluate', value: 
    function reverseEvaluate(reverseRoutingData) {
      throw new Error('Node implementation does not implement this required method.');}


    /**
     * Node implementation should return true if this node consumes path on
     * router match.
     *
     * @returns {boolean}
     */ }, { key: 'isConsumingSegmentOnMatch', value: 
    function isConsumingSegmentOnMatch() {
      throw new Error('Node implementation does not implement this required method.');}


    /**
     * Check if this node instance is equals to the other node. Allows us to
     * construct graph, so routing can be done faster.
     *
     * @param {Node} node
     * @returns {boolean}
     */ }, { key: 'equals', value: 
    function equals(node) {
      throw new Error('Node implementation does not implement this required method.');} }]);return Node;})();exports['default'] = Node;module.exports = exports['default']; /**
                                                                                                                                                                             * @type {Array<Node>}
                                                                                                                                                                             */
//# sourceMappingURL=Node.js.map