'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _ReverseRoutingDataJs = require('./ReverseRoutingData.js');var _ReverseRoutingDataJs2 = _interopRequireDefault(_ReverseRoutingDataJs);var _PathNodeJs = require(
'./PathNode.js');var _PathNodeJs2 = _interopRequireDefault(_PathNodeJs);

/**
 * Used for reverse routing.
 *
 * @CLIENT-SERVER
 */var 
ReverseRouter = (function () {




















  /**
   * @param {NodeFactory} nodeFactory
   */
  function ReverseRouter(nodeFactory) {_classCallCheck(this, ReverseRouter);
    this._preProcessNodes = [];
    this._postProcessNodes = [];
    this._routeNodes = {};
    this._nodeFactory = nodeFactory;}


  /**
   * @param {string} routeId
   * @param {Array<Array<any>>} configObj
   */_createClass(ReverseRouter, [{ key: 'reg', value: 
    function reg(routeId, configObj) {
      // Don't need to do validation, since this is only used in client anyway,
      // and anything passed on to the client have received validation
      // server-side.
      var configNodes = configObj.nodes;
      if (!configNodes) {
        // Registration for 404 route. Ignore.
        return;}


      // Set nodes for reverse routing.
      // TODO: In History API navigation, we will have to take care of variables such as this, that can change when it's cached in client.
      var nodes = this._nodeFactory.createFromConfig(configNodes);
      this._routeNodes[routeId] = nodes;}


    /**
     * @param {string} routeId
     * @param {?Object} routeArgs
     * @param {?string} fragment
     * @returns {string}
     */ }, { key: 'reverseRoute', value: 
    function reverseRoute(routeId, routeArgs, fragment) {
      var routeNodes = this._routeNodes;
      if (!routeNodes.hasOwnProperty(routeId)) {
        throw new Error('Reverse routing called for uknown route: \'' + routeId + '\'.');}

      var i, nodes = routeNodes[routeId];
      var reverseRoutingData = new _ReverseRoutingDataJs2['default'](routeArgs);

      // The graph thing is only used to speed routing up.
      // Since this is executed infrequently in client, we don't have to
      // worry about such things, just do reverse evaluation with proper
      // ordering.
      for (i = 0; i < nodes.length; i++) {
        nodes[i].reverseEvaluate(reverseRoutingData);}


      return reverseRoutingData.toUrlString(fragment);} }]);return ReverseRouter;})();exports['default'] = ReverseRouter;module.exports = exports['default']; /**
                                                                                                                                                               * @type {Array<Node>}
                                                                                                                                                               */ /**
                                                                                                                                                                   * @type {Array<Node>}
                                                                                                                                                                   */ /**
                                                                                                                                                                       * @type {{[key: string]: Array<Node>}}
                                                                                                                                                                       */ /**
                                                                                                                                                                           * @type {NodeFactory}
                                                                                                                                                                           */
//# sourceMappingURL=ReverseRouter.js.map