'use strict';Object.defineProperty(exports, '__esModule', { value: true });exports['default'] = 


























server;function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}var _path = require('path');var _path2 = _interopRequireDefault(_path);var _jsYaml = require('js-yaml');var _jsYaml2 = _interopRequireDefault(_jsYaml);var _fs = require('fs');var _fs2 = _interopRequireDefault(_fs);var _webpack = require('webpack');var _webpack2 = _interopRequireDefault(_webpack);var _react = require('react');var _react2 = _interopRequireDefault(_react);var _routerRouterJs = require('../router/Router.js');var _routerRouterJs2 = _interopRequireDefault(_routerRouterJs);var _routerReverseRouterJs = require('../router/ReverseRouter.js');var _routerReverseRouterJs2 = _interopRequireDefault(_routerReverseRouterJs);var _routerDomainNodeJs = require('../router/DomainNode.js');var _routerDomainNodeJs2 = _interopRequireDefault(_routerDomainNodeJs);var _routerMethodNodeJs = require('../router/MethodNode.js');var _routerMethodNodeJs2 = _interopRequireDefault(_routerMethodNodeJs);var _routerPathNodeJs = require('../router/PathNode.js');var _routerPathNodeJs2 = _interopRequireDefault(_routerPathNodeJs);var _routerNodeFactoryJs = require('../router/NodeFactory.js');var _routerNodeFactoryJs2 = _interopRequireDefault(_routerNodeFactoryJs);var _ComponentRegisterJs = require('../ComponentRegister.js');var _ComponentRegisterJs2 = _interopRequireDefault(_ComponentRegisterJs);var _ComponentFinderJs = require('../ComponentFinder.js');var _ComponentFinderJs2 = _interopRequireDefault(_ComponentFinderJs);var _compilerWebpackWebpackCompilerJs = require('../compiler/webpack/WebpackCompiler.js');var _compilerWebpackWebpackCompilerJs2 = _interopRequireDefault(_compilerWebpackWebpackCompilerJs);var _ApplicationJs = require('../Application.js');var _ApplicationJs2 = _interopRequireDefault(_ApplicationJs); // These dependencies can all be overwritten by user.
var _registerRouterNodesJs = require('./registerRouterNodes.js');var _registerRouterNodesJs2 = _interopRequireDefault(_registerRouterNodesJs);var _createLoggerJs = require('./createLogger.js');var _createLoggerJs2 = _interopRequireDefault(_createLoggerJs);var _createErrorHandlerJs = require('./createErrorHandler.js');var _createErrorHandlerJs2 = _interopRequireDefault(_createErrorHandlerJs); /**
                                                                                                                                                                                                                                                                                                                                                                                                            * @param {Object} config
                                                                                                                                                                                                                                                                                                                                                                                                            * @SERVER
                                                                                                                                                                                                                                                                                                                                                                                                            */function server(config) {var frameworkConfig = config.frameworkConfig;var serverConfig = config.serverConfig;var clientConfig = config.clientConfig;
  var createLogger = _createLoggerJs2['default'];
  var createErrorHandler = _createErrorHandlerJs2['default'];
  var registerRouterNodes = _registerRouterNodesJs2['default'];

  // Load custom logger and error handler factory.
  if (typeof frameworkConfig.loggerFactoryFunction == 'function') {
    createLogger = frameworkConfig.loggerFactoryFunction;}

  if (typeof frameworkConfig.errorHandlerFactoryFunction == 'function') {
    createErrorHandler = frameworkConfig.errorHandlerFactorFunction;}

  if (typeof frameworkConfig.routerNodeRegistrationFunction == 'function') {
    if (!frameworkConfig.routerNodeRegistrationAbsolutePath) {
      throw new Error('You must set both routerNodeRegistrationFunction and routerNodeRegistrationFilePath to register your custom router nodes.');}

    registerRouterNodes = frameworkConfig.routerNodeRegistrationFunction;}


  var logger = createLogger(serverConfig);
  var errorHandler = createErrorHandler(serverConfig, logger);
  var nodeFactory = new _routerNodeFactoryJs2['default']();

  // Do component registration.
  var register = new _ComponentRegisterJs2['default'](logger);
  var finder = new _ComponentFinderJs2['default'](logger);
  var pageRequireContext = frameworkConfig.pageRequireContext;
  var componentRequireContext = frameworkConfig.componentRequireContext;
  var pageRequirePath = frameworkConfig.absolutePageRequirePath;
  var componentRequirePath = frameworkConfig.absoluteComponentRequirePath;

  finder.find(pageRequirePath, function (vendor, name, absDir, relativeDir) {
    register.regPage(name, absDir, pageRequireContext('./' + _path2['default'].join(relativeDir, name + '.js')));});


  finder.find(componentRequirePath, function (vendor, name, absDir, relativeDir) {
    register.regComponent(vendor, name, absDir, componentRequireContext('./' + _path2['default'].join('./', relativeDir, name + '.js')));});


  // Register default nodes for router.
  nodeFactory.registerNodeType(_routerDomainNodeJs2['default']);
  nodeFactory.registerNodeType(_routerMethodNodeJs2['default']);
  nodeFactory.registerNodeType(_routerPathNodeJs2['default']);

  // Load custom router nodes and create router.
  registerRouterNodes(nodeFactory);
  var router = new _routerRouterJs2['default'](logger, nodeFactory, register);
  var reverseRouter = new _routerReverseRouterJs2['default'](nodeFactory);

  // Load routes.
  var routes = _jsYaml2['default'].safeLoad(_fs2['default'].readFileSync(frameworkConfig.routesFilePath, 'utf8'));
  var routeId;
  for (routeId in routes) {
    if (!routes.hasOwnProperty(routeId)) continue;
    router.reg(routeId, routes[routeId]);
    reverseRouter.reg(routeId, routes[routeId]);}


  // If not found page is not set up.
  if (!router.getNotFoundRouteResult()) {
    throw new Error('404 not found page not registered! Please create a 404 not found page.');}


  var webpackDevMiddleware;
  var webpackHotMiddleware;

  if (frameworkConfig.hotReload) {
    webpackDevMiddleware = require('webpack-dev-middleware');
    webpackHotMiddleware = require('webpack-hot-middleware');}


  var compiler = new _compilerWebpackWebpackCompilerJs2['default'](
  logger, frameworkConfig, _webpack2['default'], _react2['default'], 
  webpackDevMiddleware, webpackHotMiddleware);

  var application = new _ApplicationJs2['default'](
  logger, register, routes, router, reverseRouter, errorHandler, compiler, 
  frameworkConfig, serverConfig, clientConfig);

  application.start();}module.exports = exports['default'];
//# sourceMappingURL=index.js.map